#ifndef EFL_GENERATED_EVAS_3D_TEXTURE_HH
#define EFL_GENERATED_EVAS_3D_TEXTURE_HH

extern "C"
{
#include <Efl.h>
}
#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "evas_3d_texture.eo.h"
}

#include "evas_3d_object.eo.hh"
#include "evas_common_interface.eo.hh"
#include <canvas/evas_object.eo.hh>
#include <string>

struct evas_3d_texture
      : evas_3d_object,
      efl::eo::detail::extension_inheritance<evas::common_interface>::template type< ::evas_3d_texture>

{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit evas_3d_texture(Eo* eo)
      : evas_3d_object(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit evas_3d_texture(std::nullptr_t)
      : evas_3d_object(nullptr)
   {}

   /// @brief Call the object's constructor.
   /// Should not be used with #eo_do. Only use it with #eo_do_super.
   ///
   evas_3d_texture(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : evas_3d_texture(_c0(_p))
   {}

   /// @brief Copy Constructor.
   ///
   evas_3d_texture(evas_3d_texture const& other)
      : evas_3d_object(eo_ref(other._eo_ptr()))
   {}

   ~evas_3d_texture() {}

   /// @brief Pure virtual update_notify function..
   /// Update request for the object.
   ///
   void update_notify() const
   {
      eo_do(_eo_ptr(), ::evas_3d_object_update_notify());
   }

   /// @brief Pure virtual change_notify function..
   /// Update request for the object.
   ///
   /// @param state State that is changed
   /// @param ref The Object that caused the change
   ///
   void change_notify(Evas_3D_State state_, Evas_3D_Object * ref_) const
   {
      eo_do(_eo_ptr(), ::evas_3d_object_change_notify(state_, ref_));
   }

   /// @param visible @c EINA_TRUE for visible, @c EINA_FALSE for invisible.
   ///
   bool source_visible_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::evas_3d_texture_source_visible_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param visible @c EINA_TRUE for visible, @c EINA_FALSE for invisible.
   ///
   void source_visible_set(bool visible_) const
   {
      eo_do(_eo_ptr(), ::evas_3d_texture_source_visible_set(efl::eolian::to_c(visible_)));
   }

   /// @param color_format Color format of the texture.
   /// @param pixel_format Pixel format of the data.
   /// @param w Width of the data.
   /// @param h Height of the data.
   /// @param data Pointer to the data.
   ///
   void data_set(Evas_3D_Color_Format color_format_, Evas_3D_Pixel_Format pixel_format_, int w_, int h_, const void * data_) const
   {
      eo_do(_eo_ptr(), ::evas_3d_texture_data_set(color_format_, pixel_format_, w_, h_, data_));
   }

   /// @param file Path to the image file.
   /// @param key Key in the image file.
   ///
   void file_set(std::string file_, std::string key_) const
   {
      eo_do(_eo_ptr(), ::evas_3d_texture_file_set(efl::eolian::to_c(file_), efl::eolian::to_c(key_)));
   }

   /// @param source Source evas object to be used as the texture data.
   ///
   void source_set(evas::object source_) const
   {
      eo_do(_eo_ptr(), ::evas_3d_texture_source_set(efl::eolian::to_c(source_)));
   }

   Evas_3D_Color_Format color_format_get() const
   {
      Evas_3D_Color_Format _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::evas_3d_texture_color_format_get());
      return _tmp_ret;
   }

   /// @param[out] w Pointer to receive the width of the texture size.
   /// @param[out] h Pointer to receive the height of the texture size.
   ///
   void size_get(int* w_, int* h_) const
   {
      eo_do(_eo_ptr(), ::evas_3d_texture_size_get(w_, h_));
   }

   /// @param s Wrap mode for S-axis.
   /// @param t Wrap mode for T-axis.
   ///
   void wrap_set(Evas_3D_Wrap_Mode s_, Evas_3D_Wrap_Mode t_) const
   {
      eo_do(_eo_ptr(), ::evas_3d_texture_wrap_set(s_, t_));
   }

   /// @param[out] s Pointer to receive S-axis wrap mode.
   /// @param[out] t Pointer to receive T-axis wrap mode.
   ///
   void wrap_get(Evas_3D_Wrap_Mode* s_, Evas_3D_Wrap_Mode* t_) const
   {
      eo_do(_eo_ptr(), ::evas_3d_texture_wrap_get(s_, t_));
   }

   /// @param min Minification filter used when down-scaling.
   /// @param mag Magnification filter used when up-scaling.
   ///
   void filter_set(Evas_3D_Texture_Filter min_, Evas_3D_Texture_Filter mag_) const
   {
      eo_do(_eo_ptr(), ::evas_3d_texture_filter_set(min_, mag_));
   }

   /// @param[out] min Pointer to receive the minification filter.
   /// @param[out] mag Pointer to receive the magnification filter.
   ///
   void filter_get(Evas_3D_Texture_Filter* min_, Evas_3D_Texture_Filter* mag_) const
   {
      eo_do(_eo_ptr(), ::evas_3d_texture_filter_get(min_, mag_));
   }

   static Eo_Class const* _eo_class()
   {
      return(EVAS_3D_TEXTURE_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_ref(EVAS_3D_TEXTURE_CLASS, _p._eo_raw, eo_constructor());
   }

};
template <typename T>
void _evas_3d_texture_update_notify_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   static_cast<T*>(self->this_)->update_notify();
}

template <typename T>
void _evas_3d_texture_change_notify_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_3D_State state_, Evas_3D_Object * ref_)
{
   static_cast<T*>(self->this_)->change_notify(state_, ref_);
}

template <typename T>
bool _evas_3d_texture_source_visible_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->source_visible_get();
}

template <typename T>
void _evas_3d_texture_source_visible_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool visible_)
{
   static_cast<T*>(self->this_)->source_visible_set(efl::eolian::to_cxx<bool>(visible_, std::tuple<std::false_type>()));
}

template <typename T>
void _evas_3d_texture_data_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_3D_Color_Format color_format_, Evas_3D_Pixel_Format pixel_format_, int w_, int h_, const void * data_)
{
   static_cast<T*>(self->this_)->data_set(color_format_, pixel_format_, w_, h_, data_);
}

template <typename T>
void _evas_3d_texture_file_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char * file_, const char * key_)
{
   static_cast<T*>(self->this_)->file_set(efl::eolian::to_cxx<std::string>(file_, std::tuple<std::false_type>()), efl::eolian::to_cxx<std::string>(key_, std::tuple<std::false_type>()));
}

template <typename T>
void _evas_3d_texture_source_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Object * source_)
{
   static_cast<T*>(self->this_)->source_set(efl::eolian::to_cxx<evas::object>(source_, std::tuple<std::false_type>()));
}

template <typename T>
Evas_3D_Color_Format _evas_3d_texture_color_format_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->color_format_get();
}

template <typename T>
void _evas_3d_texture_size_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int* w_, int* h_)
{
   static_cast<T*>(self->this_)->size_get(w_, h_);
}

template <typename T>
void _evas_3d_texture_wrap_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_3D_Wrap_Mode s_, Evas_3D_Wrap_Mode t_)
{
   static_cast<T*>(self->this_)->wrap_set(s_, t_);
}

template <typename T>
void _evas_3d_texture_wrap_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_3D_Wrap_Mode* s_, Evas_3D_Wrap_Mode* t_)
{
   static_cast<T*>(self->this_)->wrap_get(s_, t_);
}

template <typename T>
void _evas_3d_texture_filter_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_3D_Texture_Filter min_, Evas_3D_Texture_Filter mag_)
{
   static_cast<T*>(self->this_)->filter_set(min_, mag_);
}

template <typename T>
void _evas_3d_texture_filter_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_3D_Texture_Filter* min_, Evas_3D_Texture_Filter* mag_)
{
   static_cast<T*>(self->this_)->filter_get(min_, mag_);
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::evas_3d_texture >
{
   template <typename T>
   struct type
   {
      virtual void update_notify()
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_3d_object_update_notify());
      }

      virtual void change_notify(Evas_3D_State state_, Evas_3D_Object * ref_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_3d_object_change_notify(state_, ref_));
      }

      virtual bool source_visible_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_texture_source_visible_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void source_visible_set(bool visible_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_3d_texture_source_visible_set(efl::eolian::to_c(visible_)));
      }

      virtual void data_set(Evas_3D_Color_Format color_format_, Evas_3D_Pixel_Format pixel_format_, int w_, int h_, const void * data_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_3d_texture_data_set(color_format_, pixel_format_, w_, h_, data_));
      }

      virtual void file_set(std::string file_, std::string key_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_3d_texture_file_set(efl::eolian::to_c(file_), efl::eolian::to_c(key_)));
      }

      virtual void source_set(evas::object source_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_3d_texture_source_set(efl::eolian::to_c(source_)));
      }

      virtual Evas_3D_Color_Format color_format_get()
      {
         Evas_3D_Color_Format _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_texture_color_format_get());
            return _tmp_ret;
      }

      virtual void size_get(int* w_, int* h_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_3d_texture_size_get(w_, h_));
      }

      virtual void wrap_set(Evas_3D_Wrap_Mode s_, Evas_3D_Wrap_Mode t_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_3d_texture_wrap_set(s_, t_));
      }

      virtual void wrap_get(Evas_3D_Wrap_Mode* s_, Evas_3D_Wrap_Mode* t_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_3d_texture_wrap_get(s_, t_));
      }

      virtual void filter_set(Evas_3D_Texture_Filter min_, Evas_3D_Texture_Filter mag_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_3d_texture_filter_set(min_, mag_));
      }

      virtual void filter_get(Evas_3D_Texture_Filter* min_, Evas_3D_Texture_Filter* mag_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_3d_texture_filter_get(min_, mag_));
      }

   };
};


template<>
struct operation_description_class_size< ::evas_3d_texture >
{
   static const int value = 13;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::evas_3d_texture>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_evas_3d_texture_update_notify_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::evas_3d_object_update_notify);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_evas_3d_texture_change_notify_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::evas_3d_object_change_notify);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::_evas_3d_texture_source_visible_get_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::evas_3d_texture_source_visible_get);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::_evas_3d_texture_source_visible_set_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::evas_3d_texture_source_visible_set);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   ops[4].func = reinterpret_cast<void*>(& ::_evas_3d_texture_data_set_wrapper<T>);
   ops[4].api_func = reinterpret_cast<void*>(& ::evas_3d_texture_data_set);
   ops[4].op = EO_OP_OVERRIDE;
   ops[4].op_type = EO_OP_TYPE_REGULAR;
   ops[4].doc = NULL;

   ops[5].func = reinterpret_cast<void*>(& ::_evas_3d_texture_file_set_wrapper<T>);
   ops[5].api_func = reinterpret_cast<void*>(& ::evas_3d_texture_file_set);
   ops[5].op = EO_OP_OVERRIDE;
   ops[5].op_type = EO_OP_TYPE_REGULAR;
   ops[5].doc = NULL;

   ops[6].func = reinterpret_cast<void*>(& ::_evas_3d_texture_source_set_wrapper<T>);
   ops[6].api_func = reinterpret_cast<void*>(& ::evas_3d_texture_source_set);
   ops[6].op = EO_OP_OVERRIDE;
   ops[6].op_type = EO_OP_TYPE_REGULAR;
   ops[6].doc = NULL;

   ops[7].func = reinterpret_cast<void*>(& ::_evas_3d_texture_color_format_get_wrapper<T>);
   ops[7].api_func = reinterpret_cast<void*>(& ::evas_3d_texture_color_format_get);
   ops[7].op = EO_OP_OVERRIDE;
   ops[7].op_type = EO_OP_TYPE_REGULAR;
   ops[7].doc = NULL;

   ops[8].func = reinterpret_cast<void*>(& ::_evas_3d_texture_size_get_wrapper<T>);
   ops[8].api_func = reinterpret_cast<void*>(& ::evas_3d_texture_size_get);
   ops[8].op = EO_OP_OVERRIDE;
   ops[8].op_type = EO_OP_TYPE_REGULAR;
   ops[8].doc = NULL;

   ops[9].func = reinterpret_cast<void*>(& ::_evas_3d_texture_wrap_set_wrapper<T>);
   ops[9].api_func = reinterpret_cast<void*>(& ::evas_3d_texture_wrap_set);
   ops[9].op = EO_OP_OVERRIDE;
   ops[9].op_type = EO_OP_TYPE_REGULAR;
   ops[9].doc = NULL;

   ops[10].func = reinterpret_cast<void*>(& ::_evas_3d_texture_wrap_get_wrapper<T>);
   ops[10].api_func = reinterpret_cast<void*>(& ::evas_3d_texture_wrap_get);
   ops[10].op = EO_OP_OVERRIDE;
   ops[10].op_type = EO_OP_TYPE_REGULAR;
   ops[10].doc = NULL;

   ops[11].func = reinterpret_cast<void*>(& ::_evas_3d_texture_filter_set_wrapper<T>);
   ops[11].api_func = reinterpret_cast<void*>(& ::evas_3d_texture_filter_set);
   ops[11].op = EO_OP_OVERRIDE;
   ops[11].op_type = EO_OP_TYPE_REGULAR;
   ops[11].doc = NULL;

   ops[12].func = reinterpret_cast<void*>(& ::_evas_3d_texture_filter_get_wrapper<T>);
   ops[12].api_func = reinterpret_cast<void*>(& ::evas_3d_texture_filter_get);
   ops[12].op = EO_OP_OVERRIDE;
   ops[12].op_type = EO_OP_TYPE_REGULAR;
   ops[12].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< ::evas_3d_texture >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::evas_3d_texture, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

inline void
call_constructor(tag< ::evas_3d_texture >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::evas_3d_texture, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::evas_3d_texture>
{
   template <typename U>
   struct type
   {
      operator ::evas_3d_texture() const
      {
         return ::evas_3d_texture(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      void update_notify()
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_3d_object_update_notify());
      }

      void change_notify(Evas_3D_State state_, Evas_3D_Object * ref_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_3d_object_change_notify(state_, ref_));
      }

      bool source_visible_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::evas_3d_texture_source_visible_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void source_visible_set(bool visible_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_3d_texture_source_visible_set(efl::eolian::to_c(visible_)));
      }

      void data_set(Evas_3D_Color_Format color_format_, Evas_3D_Pixel_Format pixel_format_, int w_, int h_, const void * data_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_3d_texture_data_set(color_format_, pixel_format_, w_, h_, data_));
      }

      void file_set(std::string file_, std::string key_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_3d_texture_file_set(efl::eolian::to_c(file_), efl::eolian::to_c(key_)));
      }

      void source_set(evas::object source_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_3d_texture_source_set(efl::eolian::to_c(source_)));
      }

      Evas_3D_Color_Format color_format_get()
      {
         Evas_3D_Color_Format _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::evas_3d_texture_color_format_get());
            return _tmp_ret;
      }

      void size_get(int* w_, int* h_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_3d_texture_size_get(w_, h_));
      }

      void wrap_set(Evas_3D_Wrap_Mode s_, Evas_3D_Wrap_Mode t_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_3d_texture_wrap_set(s_, t_));
      }

      void wrap_get(Evas_3D_Wrap_Mode* s_, Evas_3D_Wrap_Mode* t_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_3d_texture_wrap_get(s_, t_));
      }

      void filter_set(Evas_3D_Texture_Filter min_, Evas_3D_Texture_Filter mag_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_3d_texture_filter_set(min_, mag_));
      }

      void filter_get(Evas_3D_Texture_Filter* min_, Evas_3D_Texture_Filter* mag_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_3d_texture_filter_get(min_, mag_));
      }

   };
};

inline Eo_Class const* get_eo_class(tag<::evas_3d_texture>)
{
   return (EVAS_3D_TEXTURE_CLASS);
}

} } }
#endif // EFL_GENERATED_EVAS_3D_TEXTURE_HH

